<template>
  <v-container style="margin-left: 10px">
    <v-row class="d-flex justify" wrap align="center">
      <v-col md="2" lg="2" sm="3">
        <v-list-item-avatar class="rounded-xl" tile size="100">
          <img :src="urlImage === null || urlImage === undefined ? profileToChange : urlImage" alt="Profile image"/>
        </v-list-item-avatar>
      </v-col>
      <v-col>
        <v-file-input
          :disabled="disabled"
          :rules="validation"
          v-model="inputImage"
          enctype="multipart/form-data"
          type="file"
          accept="image/*"
          placeholder="Seleccionar imagen"
          prepend-icon="mdi-camera"
          truncate-length="25"
          show-size
        >
        </v-file-input>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
export default {

  name: 'ImageField',
  props: {
    'validation': { type: Array },
    'disabled': { default: false, type: Boolean },
    'urlImage': { default: null, type: String },
  },
  data() {
    return {
      profileDefault: `${require('@/static/persona-ideas.png')}`,
      profileToChange: this.urlImage === null ? `${require('@/static/persona-ideas.png')}` : this.urlImage,
    };
  },
  computed: {
    inputImage: {
      get() {
        return null;
      },
      set(val) {
        if (val != null) {
          const reader = new FileReader();
          reader.readAsDataURL(val);
          reader.onload = () => {
            this.profileToChange = reader.result;
            console.log(this.profileToChange);
          };
          this.$emit('input', val);
        } else {
          this.$emit('input', this.profileDefault);
          this.profileToChange = this.profileDefault;
        }
      },
    },
  },
  methods: {

    uploadImage(e) {
      if (e != null) {
        const reader = new FileReader();
        reader.readAsDataURL(e);
        reader.onload = () => {
          this.profileToChange = reader.result;

          console.log(reader.result);
          this.$emit('inputChangeImage', reader.result);
        };
      } else {
        this.profileToChange = this.profileDefault;
        this.$emit('inputChangeImage', this.profileDefault);
      }
    },
  },
};
</script>
